#include "stdafx.h"
#include "netceiver.h"

//static int random(int max) { return (int)((double)rand() / (double)(RAND_MAX + 1) * max); }

//void gen()
//{
//	const char *fmt = "slot %d/%d | count   %d | freq    %d | status 1f |   ff18:3000:0:17c8:6b6c:8000:c758:6000 | signal %04x | snr %04x | ber %08x | unc %08x | %s\n";
//	FILE *f = fopen("c:\\temp\\netceiver\\netceiver.data", "a");
//	if (f)
//	{
//		for (int a=0; a<10000; a++)
//			fprintf(f, fmt, random(6), random(5), (int)(20.0*sin(a/100.0)+25.0), random(2000000), random(sin(a/10.0)*65535), random(cos(a/10.0)*65535), random(cos(a/10.0)*65535), random(sin(a/10.0)*65535), random(10)>1?"LOCK":"");
//		fclose(f);
//	}
//}

static NetceiverWindow *netceiverwindow;

static const char *simFile = NULL;

static clock_t m_ct;
static time_t m_tt;

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	m_ct = clock();
	m_tt = time(NULL);
	char buf[64*1024];
//	gen();
	if (lpCmdLine && *lpCmdLine)
	{
		size_t l;
		errno_t e = wcstombs_s(&l, buf, lpCmdLine, 64*1024);
		setSimFile(buf);
		//simRepeat = false;
		//simSlow = true;
		simFile = buf;
	}
	WSADATA wsa;
	int err = WSAStartup(MAKEWORD(2, 2), &wsa);
	if (err != 0) fprintf(stderr, "WSAStartup(2, 2) failed: %d\n", err);
	else if (LOBYTE(wsa.wVersion) != 2 || HIBYTE(wsa.wVersion) != 2) { fprintf(stderr, "winsock.dll >= 2.2 not found\n"); WSACleanup(); }
	else
	{
		//NC_start();
		NetceiverWindow nw;
		netceiverwindow = &nw;
		nw.run();
	}
	WSACleanup();
	return 0;
}

void showTuner(int t) { if (t<0) netceiverwindow->showAll(); else netceiverwindow->showTuner(t); }

void unexpected(clock_t t, const char *line)
{
	int ll = line ? strlen(line) : 0;
	if (!ll) return;
	if (strstr(line, "++++++ Date Time sent to CAM") == line) return;
	if (strstr(line, "##### GET PSI START SLOT ") == line) return;
	if (strstr(line, "##### GET PSI END SLOT ") == line) return;
	if (!strcmp(line, "--- GOT PAT !!!")) return;
	if (!strcmp(line, "------ GOT CADs !!!")) return;
	if (!strcmp(line, "--------- GOT CAT !!!")) return;
	if (!strcmp(line, "Done !")) return;
	if (!strcmp(line, "**********")) return;
	if (!strcmp(line, "Update ok !")) return;
	if (!strcmp(line, "ca_del_pid: end !")) return;
	if (!strcmp(line, "ca_del_pid: end !")) return;
	if (ll>4 && !strcmp(&line[4], ": Rewriting CAT pid...")) return;
	if (ll>4 && !strcmp(&line[4], ": CA PMT sent successfully !")) return;
	if (ll>4 && !strcmp(&line[4], ": CA PMT DELETED successfully !")) return;
	static FILE *f = NULL;
	if (!f) f = fopen("unexpected.log", "a");
	time_t lt = m_tt+(t-m_ct)/CLOCKS_PER_SEC;
	char buf[256];
	strftime(buf, 256, "%H%M%S", localtime(&lt)); // %Y%m%d-
	if (f)
	{
		if (simFile) fprintf(f, "%s\n", line);
		else fprintf(f, "%s:\t%s\n", buf, line);
		fflush(f);
	}
}
